routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', ['as' => 'welcome', 'uses' => 'PostController@search']);
Route::get('search', ['as' => 'welcome', 'uses' => 'PostController@search']);
Route::post('search', ['as' => 'post.search', 'uses' => 'PostController@search']);
Route::get('search/tag/{id}', ['as' => 'post.tag', 'uses' => 'PostController@tag']);
Route::get('post/{id}', ['as' => 'post.show', 'uses' => 'PostController@show'])->where(['id' => '[0-9]+']);;

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::group(['middleware' => 'auth'], function () {
    Route::resource('user', 'UserController', ['except' => ['show']]);
    Route::get('profile', ['as' => 'profile.edit', 'uses' => 'ProfileController@edit']);
    Route::put('profile', ['as' => 'profile.update', 'uses' => 'ProfileController@update']);
    Route::put('profile/password', ['as' => 'profile.password', 'uses' => 'ProfileController@password']);
});

Route::group(['middleware' => 'auth'], function () {
    Route::resource('post', 'PostController');
});

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    public const PUBLISHED = 2;
    public const ON_APPROVAL = 1;
    public const UNPUBLISHED = 0;

    public function user()
    {
        return $this->hasOne(User::class, 'id', 'user_id');
    }

    public function category()
    {
        return $this->hasOne(PostCategory::class, 'post_id', 'id');
    }

    public function image()
    {
        return $this->hasOne(PostImage::class, 'post_id', 'id');
    }

    public function tags()
    {
        return $this->hasMany(PostTag::class, 'post_id', 'id');
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Category;
use App\Http\Requests\PostRequest;
use App\Post;
use App\PostCategory;
use App\PostImage;
use App\PostTag;
use App\Tag;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Gate;
use Illuminate\Support\Facades\Mail;
use Illuminate\View\View;

class PostController extends Controller
{
    /**
     * Display a listing of the posts.
     *
     * @return View
     */
    public function index(Post $model)
    {
        return view('posts.index', ['posts' => $model->paginate(15)]);
    }

    /**
     * Display posts by the specified search query.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return View
     */
    public function search(Request $request)
    {
        $posts = Post::where('status', Post::PUBLISHED)
            ->where(function($q) use ($request) {
                    return $q->where('title', 'LIKE', '%' . $request->input('query') . '%')
                        ->orWhere('text', 'LIKE', '%' . $request->input('query') . '%');
            })
            ->orderBy('published_at', 'DESC')->paginate(12);

        return view('welcome', ['posts' => $posts, 'query' => $request->input('query')]);
    }

    /**
     * Display posts with the specified tag.
     *
     * @param  int  $id
     * @return View
     */
    public function tag($id)
    {
        $posts = Post::where('status', Post::PUBLISHED)->whereHas('tags', function ($query) use ($id) {
            return $query->where('tag_id', '=', $id);
        })->orderBy('published_at', 'DESC')->paginate(12);

        $tag = Tag::find($id);

        return view('welcome', ['posts' => $posts, 'tag' => $tag]);
    }

    /**
     * Show the form for creating a new post.
     *
     * @return View
     */
    public function create()
    {
        return view('posts.create', [
            'categories' => Category::all(),
            'tags' => Tag::all()
        ]);
    }

    /**
     * Store a newly created post in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  Post  $post
     * @return \Illuminate\Http\Response
     */
    public function store(PostRequest $request, Post $post)
    {
        $post->title = $request->input('title');
        $post->text = $request->input('text');
        $post->user_id = $request->user()->id;
        $post->status = Post::UNPUBLISHED;
        $post->save();

        $post->category()->save(new PostCategory(['category_id' => $request->input('category')]));

        $image_name = time().'.'.$request->image->extension();
        $request->image->move(public_path('images/posts'), $image_name);

        $post->image()->save(new PostImage(['image' => $image_name]));

        foreach ($request->input('tags') as $tag)
        {
            $postTag = new PostTag(['tag_id' => $tag]);

            $post->tags()->save($postTag);
        }

        return redirect()->route('post.edit', $post)->withStatus(__('Post successfully created.'));
    }

    /**
     * Display the specified post.
     *
     * @param  int  $id
     * @return View
     */
    public function show($id)
    {
        return view('post', ['post' => Post::find($id)]);
    }

    /**
     * Show the form for editing the specified post.
     *
     * @param  Post  $post
     * @return View
     */
    public function edit(Post $post)
    {
        if (! Gate::allows('edit-post', $post)) {
            abort(403);
        }

        $categories = Category::all();
        $tags = Tag::all();

        return view('posts.edit', compact('post', 'categories', 'tags'));
    }

    /**
     * Update the specified post in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  Post $post
     * @return \Illuminate\Http\Response
     */
    public function update(PostRequest $request, Post $post)
    {

        if (! Gate::allows('update-post', $post)) {
            abort(403);
        }

        $post->title = $request->input('title');
        $post->text = $request->input('text');

        if ($request->input('publish')) {
            if (Gate::allows('publish-post', $post)) {
                $post->status = Post::PUBLISHED;
            } else {
                $post->status = Post::ON_APPROVAL;
                Mail::to(User::where('role', 'admin')->first()->email)->send(new \App\Mail\PublishPostNotification($post));
            }
        } else {
            if($post->status == Post::ON_APPROVAL || $post->status == Post::ON_APPROVAL) {
                $post->status = Post::ON_APPROVAL;
            } else {
                $post->status = Post::UNPUBLISHED;
            }
            $post->published_at = null;
        }

        $post->save();

        if ($request->image)
        {
            $image_name = time().'.'.$request->image->extension();
            $request->image->move(public_path('images/posts'), $image_name);

            $post->image()->update(['image' => $image_name]);
        }

        $post->category()->update(['category_id' => $request->input('category')]);

        $post->tags()->delete();

        foreach ($request->input('tags') as $tag)
        {
            $post->tags()->create(['tag_id' => $tag]);
        }

        return redirect()->route('post.edit', $post)->withStatus(__('Post successfully updated.'));
    }

    /**
     * Remove the specified post from storage.
     *
     * @param  int  $id
     * @return View
     */
    public function destroy(Post $post)
    {
        if (! Gate::allows('delete-post', $post)) {
            abort(403);
        }

        $post->delete();

        return view('posts.index', ['posts' => Post::paginate(15)]);
    }
}

resources/views/posts/create.blade.php
@extends('layouts.app', ['title' => __('Post Management')])

@section('content')
    @include('users.partials.header', ['title' => __('Add Post')])

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col-xl-12 order-xl-1">
                <div class="card bg-secondary shadow">
                    <div class="card-header bg-white border-0">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">{{ __('Post Management') }}</h3>
                            </div>
                            <div class="col-4 text-right">
                                <a href="{{ route('post.index') }}" class="btn btn-sm btn-primary">{{ __('Back to list') }}</a>
                            </div>
                        </div>
                    </div>
                    <div class="card-body">
                        <form method="post" action="{{ route('post.store') }}" autocomplete="off" enctype="multipart/form-data">
                            @csrf

                            <h6 class="heading-small text-muted mb-4">{{ __('Post information') }}</h6>
                            <div class="pl-lg-4">
                                <div class="col-12 pr-0 pl-0 float-left">
                                    <div class="form-group{{ $errors->has('title') ? ' has-danger' : '' }}">
                                        <label class="form-control-label" for="input-title">{{ __('Title') }}</label>
                                        <input type="text" name="title" id="input-title" class="form-control form-control-alternative{{ $errors->has('title') ? ' is-invalid' : '' }}" placeholder="{{ __('Title') }}" value="{{ old('title') }}" required autofocus>

                                        @if ($errors->has('title'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('title') }}</strong>
                                            </span>
                                        @endif
                                    </div>
                                </div>

                                <div class="col-md-6 pr-0 pl-0 pr-md-4 pl-md-0 float-left">
                                    <div class=" form-group{{ $errors->has('category') ? ' has-danger' : '' }}">
                                        <label class="form-control-label" for="select-category" >{{ __('Category') }}</label>
                                        <select name="category" id="select-category" class="form-control{{ $errors->has('category') ? ' is-invalid' : '' }}" required>
                                            @foreach($categories as $category)
                                            <option value="{{ $category->id }}">{{ $category->name }}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>

                                <div class="col-md-6 pr-0 pl-0 pl-md-4 pr-md-0 float-left">
                                    <div class=" form-group{{ $errors->has('tags') ? ' has-danger' : '' }}">
                                        <label class="form-control-label" for="select-tags" >{{ __('Tags') }}</label>
                                        <select multiple name="tags[]" id="select-tags" class="form-control{{ $errors->has('tags[]') ? ' is-invalid' : '' }}" required>
                                            @foreach($tags as $tag)
                                                <option value="{{ $tag->id }}">{{ $tag->name }}</option>
                                            @endforeach
                                        </select>
                                        @if ($errors->has('tags[]'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('tags[]') }}</strong>
                                            </span>
                                        @endif
                                    </div>
                                </div>

                                <div class="col-12 pr-0 pl-0 float-left">
                                    <div class="form-group{{ $errors->has('text') ? ' has-danger' : '' }}">
                                        <label class="form-control-label" for="input-text">{{ __('Text') }}</label>
                                        <textarea name="text" id="input-text" class="form-control form-control-alternative{{ $errors->has('text') ? ' is-invalid' : '' }}" placeholder="{{ __('Text') }}" required style="min-height: 300px;">{{ old('text') }}</textarea>
                                        @if ($errors->has('text'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('text') }}</strong>
                                            </span>
                                        @endif
                                    </div>

                                    <div class="form-group{{ $errors->has('image') ? ' has-danger' : '' }}">
                                        <label class="form-control-label" for="input-image">{{ __('Image') }}</label>
                                        <input type="file" accept="image/png, image/jpeg, image/jpg" name="image" id="input-image" class="form-control form-control-alternative{{ $errors->has('image') ? ' is-invalid' : '' }}" required/>
                                        @if ($errors->has('image'))
                                            <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('image') }}</strong>
                                            </span>
                                        @endif
                                    </div>

                                    <div class="text-center">
                                        <button type="submit" class="btn btn-success mt-4">{{ __('Save') }}</button>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>

        @include('layouts.footers.auth')
    </div>
@endsection

resources/views/posts/edit.blade.php
@extends('layouts.app', ['title' => __('Post Management')])

@section('content')
    @include('users.partials.header', ['title' => __('Edit Post')])

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col-xl-12 order-xl-1">
                <div class="card bg-secondary shadow">
                    <div class="card-header bg-white border-0">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">
                                    {{ __('Post status') }}:
                                    @if($post->status == 0)
                                        <span class="badge badge-primary" style="font-size: 14px;">{{ __('Unpublished') }}</span>
                                    @elseif($post->status == 1)
                                        <span class="badge badge-info" style="font-size: 14px;">{{ __('On approval') }}</span>
                                    @elseif($post->status == 2)
                                        <span class="badge badge-success" style="font-size: 14px;">{{ __('Published') }}</span>
                                    @endif
                                </h3>
                            </div>
                            <div class="col-4 text-right">
                                <a href="{{ route('post.index') }}" class="btn btn-sm btn-primary">{{ __('Back to list') }}</a>
                            </div>
                        </div>
                    </div>
                    <div class="card-body">
                        <form method="post" action="{{ route('post.update', $post) }}" autocomplete="off" enctype="multipart/form-data">
                            @csrf
                            @method('put')

                            <h6 class="heading-small text-muted mb-4">{{ __('Post information') }}</h6>
                            <div class="pl-lg-4">
                                <div class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
                                    <label class="form-control-label" for="input-title">{{ __('Title') }}</label>
                                    <input type="text" name="title" id="input-title" class="form-control form-control-alternative{{ $errors->has('title') ? ' is-invalid' : '' }}" placeholder="{{ __('Title') }}" value="{{ old('title', $post->title) }}" required autofocus>

                                    @if ($errors->has('title'))
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $errors->first('title') }}</strong>
                                        </span>
                                    @endif
                                </div>

                                <div class="col-md-6 pr-0 pl-0 pr-md-4 pl-md-0 float-left ">
                                    <div class=" form-group{{ $errors->has('category') ? ' has-danger' : '' }}">
                                        <label class="form-control-label" for="select-category" >{{ __('Category') }}</label>
                                        <select multiple name="category" id="select-category" class="form-control{{ $errors->has('category') ? ' is-invalid' : '' }}" required>
                                            @foreach($categories as $category)
                                                @if($category->id == $post->category->category_id)
                                                    <option value="{{ $category->id }}" selected>{{ $category->name }}</option>
                                                @else
                                                    <option value="{{ $category->id }}">{{ $category->name }}</option>
                                                @endif
                                            @endforeach
                                        </select>
                                    </div>
                                </div>

                                <div class="col-md-6 pr-0 pl-0 pl-md-4 pr-md-0 float-left">
                                    <div class=" form-group{{ $errors->has('tags') ? ' has-danger' : '' }}">
                                        <label class="form-control-label" for="select-tags" >{{ __('Tags') }}</label>
                                        <select multiple name="tags[]" id="select-tags" class="form-control{{ $errors->has('tags') ? ' is-invalid' : '' }}" required>
                                            @foreach($tags as $tag)
                                                @if(in_array($tag->id, array_column($post->tags->toArray(), 'tag_id')))
                                                    <option value="{{ $tag->id }}" selected>{{ $tag->name }}</option>
                                                @else
                                                    <option value="{{ $tag->id }}">{{ $tag->name }}</option>
                                                @endif
                                            @endforeach
                                        </select>
                                    </div>
                                </div>

                                <div class="form-group{{ $errors->has('text') ? ' has-danger' : '' }}">
                                    <label class="form-control-label" for="input-text">{{ __('Text') }}</label>
                                    <textarea name="text" id="input-text" class="form-control form-control-alternative{{ $errors->has('text') ? ' is-invalid' : '' }}" placeholder="{{ __('Text') }}" required style="min-height: 300px;">{{ old('text', $post->text) }}</textarea>
                                    @if ($errors->has('text'))
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $errors->first('text') }}</strong>
                                        </span>
                                    @endif
                                </div>

                                <div class="form-group float-left col-12 d-flex flex-wrap flex-direction-row align-items-center{{ $errors->has('image') ? ' has-danger' : '' }}">
                                    <label class="form-control-label col-12" for="input-image">{{ __('Image') }}</label>
                                    <input type="file" accept="image/png, image/jpeg" name="image" id="input-image" class="form-control col-md-3 col-12 float-left form-control-alternative{{ $errors->has('image') ? ' is-invalid' : '' }}"/>
                                    @if ($errors->has('image'))
                                        <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('image') }}</strong>
                                            </span>
                                    @endif
                                    @if($post->image)
                                        <div class="col-md-9 col-12 float-left d-flex justify-content-center">
                                            <img style="max-width: 90%; border-radius: .375rem;" src="{{ asset('images/posts') }}/{{ $post->image->image }}">
                                        </div>
                                    @endif
                                </div>

                                <div class="text-center col-12 float-left">
                                    <button type="submit" class="btn btn-primary mt-4">{{ __('Save') }}</button>
                                    @if(Gate::allows('publish-post', $post))
                                        @if($post->status == 0 || $post->status == 1)
                                            <input type="submit" name="publish" class="btn btn-success mt-4" value="{{ __('Publish') }}">
                                        @else
                                            <input type="submit" name="unpublish" class="btn btn-secondary mt-4" value="{{ __('Unpublish') }}">
                                        @endif
                                    @else
                                        @if($post->status == 1 || $post->status == 2)
                                            <input type="submit" name="unpublish" class="btn btn-secondary mt-4" value="{{ __('Unpublish') }}">
                                        @else
                                            <input type="submit" name="publish" class="btn btn-success mt-4" value="{{ __('Publish') }}">
                                        @endif
                                    @endif
                                    <button type="button" class="btn btn-danger mt-4" onclick="confirm('{{ __("Are you sure you want to delete this post?") }}') ? document.getElementById('delete-post-form').submit() : ''">{{ __('Delete') }}</button>
                                </div>
                            </div>
                        </form>
                        <form action="{{ route('post.destroy', $post) }}" id="delete-post-form" method="post">
                            @csrf
                            @method('delete')
                        </form>
                    </div>
                </div>
            </div>
        </div>

        @include('layouts.footers.auth')
    </div>
@endsection

resources/views/posts/index.blade.php
@extends('layouts.app', ['title' => __('Post Management')])

@section('content')
    @include('users.partials.header', ['title' => __('Post Management')])

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">{{ __('Posts') }}</h3>
                            </div>
                            <div class="col-4 text-right">
                                <a href="{{ route('post.create') }}" class="btn btn-sm btn-primary">{{ __('Add post') }}</a>
                            </div>
                        </div>
                    </div>

                    <div class="col-12">
                        @if (session('status'))
                            <div class="alert alert-success alert-dismissible fade show" role="alert">
                                {{ session('status') }}
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                        @endif
                    </div>

                    <div class="table-responsive">
                        <table class="table align-items-center table-flush">
                            <thead class="thead-light">
                                <tr>
                                    <th scope="col">{{ __('Title') }}</th>
                                    <th scope="col">{{ __('Author') }}</th>
                                    <th scope="col">{{ __('Creation Date') }}</th>
                                    <th scope="col"></th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($posts as $post)
                                    <tr>
                                        <td>{{ $post->title }}</td>
                                        <td>{{ $post->user->name }}</td>
                                        <td>{{ $post->created_at->format('m.d.Y') }}</td>
                                        <td class="text-right">
                                            <div class="dropdown">
                                                <a class="btn btn-sm btn-icon-only text-light" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                    <i class="fas fa-ellipsis-v"></i>
                                                </a>
                                                @if(Gate::allows('delete-post', $post) || Gate::allows('edit-post', $post))
                                                    <div class="dropdown-menu dropdown-menu-right dropdown-menu-arrow">
                                                        @if(Gate::allows('edit-post', $post))
                                                            <a class="dropdown-item" href="{{ route('post.edit', $post) }}">{{ __('Edit') }}</a>
                                                        @endif

                                                        @if (Gate::allows('delete-post', $post))
                                                            <form action="{{ route('post.destroy', $post) }}" method="post">
                                                                @csrf
                                                                @method('delete')
                                                                <button type="button" class="dropdown-item" onclick="confirm('{{ __("Are you sure you want to delete this post?") }}') ? this.parentElement.submit() : ''">
                                                                    {{ __('Delete') }}
                                                                </button>
                                                            </form>
                                                        @endif
                                                    </div>
                                                @else
                                                    <div class="dropdown-menu dropdown-menu-right dropdown-menu-arrow">
                                                        <a class="dropdown-item disabled">No actions available</a>
                                                    </div>
                                                @endif
                                            </div>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                    <div class="card-footer py-4">
                        <nav class="d-flex justify-content-end" aria-label="...">
                            {{ $posts->links() }}
                        </nav>
                    </div>
                </div>
            </div>
        </div>

        @include('layouts.footers.auth')
    </div>
@endsection